<?php
$lot = 100; // nombre de pages visibles

include("inc_connexion.php");

// requete SQL qui retourne une valeur unique 
// la clef de chacune des colonnes reprsente le nom du champ correspondant de la ou des table(s) 
function mysql_requete_valeur($chaine_sql) {
  connexion_base();
  $requete = mysql_query($chaine_sql);
  if ($requete) {
    $ligne = mysql_fetch_array($requete); 
    mysql_free_result($requete);
	foreach ($ligne as $cle => $valeur)
	  $resultat = $valeur;
  }
  else {
    $tableau = null;
	// echo mysql_error();
  }
  mysql_close();
  return $resultat;
}

// requete SQL qui retourne un tableau associatif  2 dimensions : lignes et colonnes, 
// la clef de chacune des colonnes reprsente le nom du champ correspondant de la ou des table(s) 
function mysql_requete($chaine_sql) {
  if (connexion_base()) {
    $requete = mysql_query($chaine_sql);
    if ($requete) {
      while($ligne = mysql_fetch_array($requete)) 
        $tableau[] = $ligne;
      mysql_free_result($requete);
    }
    else {
      $tableau = null;
	  // echo mysql_error();
    }
    mysql_close();
    return $tableau;
  }
  else return null;
}

// requete SQL qui retourne un seul enregistrement, soit un tableau associatif, 
// la clef de chacune des colonnes reprsente le nom du champ correspondant de la ou des table(s) 
function mysql_requete_ligne($chaine_sql) {
  connexion_base();
  $requete = mysql_query($chaine_sql);
  if ($requete) {
    $ligne = mysql_fetch_array($requete); 
    mysql_free_result($requete);
  }
  else {
    $ligne = null;
	echo mysql_error();
  }
  mysql_close();
  return $ligne;
}

// coupe une chane  $limite caractres, sans coupure de mot
// (un mot est considr comme un groupe de caractres spar par des espaces)
function tronquer_texte($texte, $limite) {
  // la longueur du texte est <= $limite, on retourne le texte entier
  if (strlen($texte) <= $limite) return $texte;
  // on remplace les <br> par des espaces
  $texte = str_replace("<br>", " ", $texte);
  // on fait la coupure avant le 1e espace aprs $limite caractres
  $pos = strpos(substr($texte, $limite), " ");
  // s'il y a un espace aprs $limite caractres ou juste aprs $limite caractres
  // on retourne la partie de $texte jusqu'avant cet espace
  if (is_integer($pos) || $pos) return substr($texte, 0, $limite+$pos) . " (...)";
  // sinon (pas d'espace aprs $limite caractres ou juste aprs $limite caractres) on retourne le texte
  else return $texte;
}

// fait l'inverse : convertit un datetime MySQL "AAAA-MM-JJ HH:MM:SS" en "JJ/MM/AAAA" ou "JJ.MM.AAAA"
function convertit_mysql_datetime($datetime_mysql) {
  $date_mysql = strtok($datetime_mysql, " ");
  list($annee,$mois,$jour) = explode("-",$date_mysql); 
  return $jour . "/" . $mois . "/" . $annee;
}

// convertit un tableau $tableau[$i] = array($indice => "valeur0", "val1" => "valeur1", "val2" => "valeur2"...)
// en un tableau $nouv_tableau["valeur0"] = array("val1" => "valeur1", "val2" => "valeur2"...]
function indice_tableau($tableau, $indice) {
  for ($i=0;$i<count($tableau);$i++) {
	$ind = $tableau[$i][$indice];
    foreach ($tableau[$i] as $cle => $valeur) {
	  if ($cle != $indice) $nouv_tableau[$ind][$cle] = $valeur;
    }
  }
  return $nouv_tableau;
} 

// "127.4 ko" ou "3.1 Mo"
function taille_en_octets ($taille) {
	if ($taille < 1024) $taille = $taille . " octets";
	else if ($taille < 1024*1024) 
		$taille = (floor($taille / 102.4))/10 . " ko";
	else $taille = (floor(($taille / 1024) / 102.4))/10 . " Mo";
	return $taille;
}


// taille d'une base
function taille_base($base) {
  connexion_base();
  $requete = "SHOW TABLE STATUS FROM $base";
  $ressource = mysql_query($requete);
  while ($resultat = mysql_fetch_array($ressource)) {
    $taille = $resultat[Data_length]+$resultat[Index_length];
    echo $resultat[Name].": ".round(($taille/1024),2)."<br />";
    $tot += $taille;
    // print_r($resultat); //Pour afficher le tableau entier contenant les infos de ta table
  }
  $total = round(($tot/1024),2);
  return $total;
}

// nom du site
function nom_du_site($spip) {
  $requete = "SELECT valeur FROM " . $spip . "_meta WHERE nom='nom_site'";
  return mysql_requete_valeur($requete);
}

// en-tte de page
function entete_page($url_cour, $page, $nb_items) {
   global $lot; // nombre de lignes par page (valeur dans inc_utils.php)
   $args = func_get_args();
   // pagination
   if (($lot) && ($lot < $nb_items)) {
      echo "<tr><td colspan='" . (count($args)-3) . "' align='center'>"; 
	  echo "<table cellspacing='0' cellpadding='0' border='0'><tr>";
      page_precedente($url_cour, $page);
      echo "<td>pages</td>";
      page_suivante($url_cour, $page, $nb_items);
      echo "</tr></table></td></tr>";
   }
   // en-tte de colonnes
   echo "<tr>";
   for ($i=3;$i<count($args);$i++) echo "<th class='liste'>$args[$i]</th>";
   echo "</tr>";
}

// pagination : vers la page prcdente
function page_precedente($page_cour, $page) {
   global $lot;
   if ($lot) {
      if ($page > 0) {
	     $page--;
         echo "<td><a href='$page_cour?page=$page'><img src='prec.gif' border='0' width='22' height='18'></a></td>";
      }
	  else echo "<td><img src='prec_gr.gif' border='0' width='22' height='18'></td>";
   }
}

// pagination : vers la page suivante
function page_suivante($page_cour, $page, $nb_items) {
   global $lot;
   if ($lot) {
      $total_pages = ceil($nb_items / $lot);
      if ($page < $total_pages-1) {
         $page++;
         echo "<td><a href='$page_cour?page=$page'><img src='suiv.gif' border='0' width='22' height='18'></a></td>";
      }
      else echo "<td><img src='suiv_gr.gif' border='0' width='22' height='18'></td>";
   }
}


?>