<?php
if (defined("_INC_CONFIG")) return;
define("_INC_CONFIG", "1");

$nom_base = "";
$adr_base = "";
$login = "";
$passe = "";
if (infos_connexion()) {
   $_SESSION["nom_base"] = $nom_base;
   $_SESSION["adr_base"] = $adr_base;
   $_SESSION["login"] = $login;
   $_SESSION["passe"] = $passe;
}
$prefix_spip = trouve_prefix_spip();
if (!$prefix_spip) $prefix_spip = "spip";
$_SESSION["prefix"] = $prefix_spip;
$racine = racine_spip("spip_cache.php");
$_SESSION["racine"] = $racine;


// rcupration des infos de connexion
function infos_connexion() {
   global $nom_base, $adr_base, $login, $passe;
   $trouve = false;
   $fichier = cherche_fichier_php("/ecrire/inc_connect.php");
   if ($fichier) {
      $lignes = file($fichier);
      $i = 0;
      while ($i < count($lignes)) {
          $pos = strpos($lignes[$i], "spip_connect_db(");
          if ($pos === false) $i++;
	      else break;
      }
      if ($i < count($lignes)) {
	      $pos1 = $pos + strlen("spip_connect_db(");
          $ch = substr($lignes[$i], $pos1, strlen($lignes[$i])-$pos1-3);
	      $ch = str_replace("'", "", $ch);
	      list($adr_base, $xx, $login, $passe, $nom_base) = explode(",", $ch);
		  $trouve = true;
      }
      else echo "Impossible de rcuprer vos informations de connexion";
   }
   else echo "Impossible de trouver votre fichier 'inc_connect.php3' ou .php";
   return $trouve;
}

// recherche d'un fichier PHP ou PHP3 dans l'arborescence  partir du fichier actuel
function cherche_fichier_php($fichier) {
   $rel = "/..";
   for ($i=0;$i<5;$i++) {
      if (file_exists("." . $fichier)) break;
      else if (file_exists("." . $fichier . "3")) {
         $fichier = $fichier . "3";
	     break;
      }
      else $fichier = $rel . $fichier;
   }
   if ($i < 5) return "." . $fichier;
   else return null;
}

// dtermination du prfixe spip
function trouve_prefix_spip() {
   // recherche du fichier "ecrire/inc_version.php" ou php3
   $fichier = cherche_fichier_php("/ecrire/inc_version.php", true);
   if ($fichier) {
      // recherche de la version SPIP
	  // avant la version 5, le prefixe est stock dans inc_version.php,
	  // aprs, il faut voir dans ecrire/mes_options.php3
	  $ligne = cherche_info_fichier("\$spip_version_affichee", $fichier);
	  if ($ligne) {
	     $version = substr(valeur_variable($ligne), 0, 3);
	     // on rcupre quand mme le prfixe dans "inc_version.php3", 
	     // au cas o il y aurait t directement modifi
		 $ligne = cherche_info_fichier("\$table_prefix", $fichier);
         if ($ligne) $prefix = valeur_variable($ligne);
	     // si la version est > 1.4, on va voir s'il existe un fichier "mes_options.php3"
	     if ($version >= "1.4") {
	        $fichier = cherche_fichier_php("/ecrire/mes_options.php", true);
		    if ($fichier) {
	           $ligne = cherche_info_fichier("\$table_prefix", $fichier);
               if ($ligne) $prefix = valeur_variable($ligne);
            }
         }
		 return $prefix;
      }
	  else return null;
   }
   else return null;
}

// recherche dans un fichier une ligne contenant une chane donne
function cherche_info_fichier($chaine, $fichier) {
   $f = fopen($fichier, "r");
   if ($f) {
      while (!feof($f)) {
         $ligne = chop(fgets($f, 2048));
	     if (strpos($ligne, $chaine) !== false) {
	        fclose($f);
	        return $ligne;
         }
      }
      fclose($f);
      return null;
   }
   else return null;
}

// donne la valeur d'une variable dans une ligne $variable = "valeur";
function valeur_variable($ligne) {
   $valeur = strtok($ligne, '"');
   $valeur = strtok('"');
   return $valeur;
}

// recherche le fichier spip_cache.php3 (ou spip_cache.php)
// pour dterminer le chemin de la racine
function racine_spip($fichier, $php3=true) {
   $base_dir = ".";
   $rel = "../";
   for ($i=0;$i<5;$i++) {
      if (file_exists($fichier)) break;
      else if ($php3 && file_exists($fichier . "3")) break;
      else {
         $fichier = ($i ? "" : "./") . $rel . $fichier;
         $base_dir .= "/..";
      }
   }
   if ($i < 5) return $base_dir;
   else return null;
}

?>